#ifndef _COMMONGUARD
#define _COMMONGUARD

//C, C PLUS PLUS, AND ASSEMBLER------------------------------
#ifndef PI
#define PI 3.141592653589793f
#endif

#define ANGLETORAD 0.017453292519943295555555555555556
#define DEGTORAD (180/PI)

#define DVector2DShift 8

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE ~FALSE
#endif

//GBR register offsets for assembler, C, and C++
#define GLOBALBASE 			(0)
#define BYTEOFFSET(a)			(GLOBALBASE + a)

//byte sized gbr offsets
#define GPASS				BYTEOFFSET(0) /* opaque, trans, punch */

#define GBRBYTELAST			(FIRST_PASS+1)
#define WORDOFFSET(a) 			(GBRBYTELAST + (GBRBYTELAST & 1) + 2 * (a))	/* align to word boundry */

//word sized gbr offsets
#define GWORD				(WORDOFFSET(0))

#define GBRWORDLAST			(GWORD+2)
#define LONGOFFSET(a) 			(GBRWORDLAST + (GBRWORDLAST & 2) + 4 * (a))	/* align to long boundry */

//long sized gbr offsets
#define OPAQUE_STACK			(LONGOFFSET(0)) /* pointers to draw stacks */
#define OPAQUEMOD_STACK			(LONGOFFSET(1))
#define BLEND_STACK			(LONGOFFSET(2))
#define BLENDMOD_STACK			(LONGOFFSET(3))
#define PUNCH_STACK			(LONGOFFSET(4))

#define GBRLONGLAST			(PUNCH_STACK)

#if (GBRBYTELAST > 255)
	#error GBR byte offsets out of range
#endif
#if (GBRWORDLAST > 255*2)
	#error GBR word offsets out of range
#endif
#if (GBRLONGLAST > 255*4)
	#error GBR long offsets out of range
#endif
#if (GBRWORDLAST & 1)
	#error GBR word offsets not word aligned
#endif
#if (GBRLONGLAST & 3)
	#error GBR long offsets not word aligned
#endif

#ifdef __ASSEMBLER__
	#include "common_asm.h"
#else
	#include "common_c.h"
	#ifdef __cplusplus
		#include "common_cpp.h"
	#endif
#endif

#endif

