#ifndef _COMMON_C_GUARD
#define _COMMON_C_GUARD

//C and C PLUS PLUS TYPES AND DEFINES------------------------------
#ifdef __cplusplus
extern "C" {
#endif

#include "debug.h"
#include <stdlib.h>

#define ALIGN8BYTE __attribute__((aligned(8)))
#define ALIGN32BYTE __attribute__((aligned(32)))

#ifndef min
	#define min(a,b) (((a) < (b)) ? (a) : (b))
#endif
#ifndef max
	#define max(a,b) (((a) > (b)) ? (a) : (b))
#endif
#ifndef clamp
	#define clamp(small,num,big) (max((small),min((num),(big))))
#endif
#ifndef between
	#define between(small,val,big) (((small) <= (val)) && ((val) <= (big)))
#endif

#define DEG_TO_ANGLE(x)	(int)((float)(x) * (float)(1<<16) / 360)

#define SWIZZLE_POINTER(pntr,offset) (typeof pntr)((uintptr_t)pntr + (uintptr_t)offset)

typedef int Angle;
typedef float radians;
typedef float fdegrees;

void SaveScreenshot();
int SaveString(const char * filename, char * string);
char * LoadString(const char * filename);
void * LoadCompressed(const char * fname);
void * LoadCompressed2(const char * fname);

#ifdef __arch_dreamcast
	#include "sh4.h"
	void InitGBR();
	extern int GLOBAL[256];
#endif

#ifdef __cplusplus
}
#endif

#endif

