#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "common.h"
#include "debug.h"
#ifdef _arch_dreamcast
	#include "sh4.h"
#endif

int GLOBAL[256];

void SaveScreenshot()
{
	watchdog_pause();
	int curshot = 0;
	char namebuf[150];
	
	FILE * inf;
	inf = fopen ("/pc/shots/curshot.bin","r");
	if (inf != NULL) {
		fread(&curshot,sizeof(curshot),1,inf);
		fclose(inf);
	}
	sprintf(namebuf,"/pc/shots/%08i.pbm",curshot);
	
	vid_screen_shot(namebuf);
	
	curshot++;
	inf = fopen ("/pc/shots/curshot.bin","w");
	if (inf != NULL) {
		fwrite(&curshot,sizeof(curshot),1,inf);
		fclose(inf);
	} else {
		DBOS("Screenshot error\n");
	}
	watchdog_resume();
}

int SaveString(const char * filename, char * string)
{
	FILE * of;
	int result;
	
	of = fopen (filename,"w");
	if (of!=NULL) {
		fputs (string,of);
		fclose (of);
		result = 0;
	} else {
		result = 1;
	}
	
	return result;
}

char * LoadString(const char * filename)
{
	FILE * inf;
	size_t len = 0;
	const int resize_step = 2000;
	char * buff = malloc(32);
	
	inf = fopen (filename,"r");
	if (inf != NULL) {
		while(!feof(inf)) {	//resize buffer until it all fits
			buff = realloc(buff,len+resize_step+1);
			len += fread(buff+len,sizeof(char),resize_step, inf);
		}
		fclose(inf);
		buff[len] = 0;
		buff = realloc(buff,len+1);	//trim excess
	}
	return buff;
}

#include <zlib/zlib.h>
int zlib_getlength(const char *filename);
//TODO function so that it doesn't require KOS-only getlength extention
void * LoadCompressed(const char * fname)
{
	char *data;
	int length = zlib_getlength(fname);
	gzFile f;

	data = (char *)memalign(32,length);

	f = gzopen(fname, "r");
	gzread(f, data, length);
	//data[length] = 0;
	gzclose(f);
	DBOS("length [%d]\n", length);
	
	return (void*)data;
}

void * LoadCompressed2(const char * fname)
{
	gzFile f;
	size_t len = 0;
	const int resize_step = 4000;
	char * data = malloc(32);

	f = gzopen(fname, "r");
	if (f != NULL) {
		while(!gzeof(f)) {	//resize buffer until it all fits
			data = realloc(data,len+resize_step);
			len += gzread(f,data+len,resize_step);
		}
		gzclose(f);
		data = realloc(data,len);	//trim excess
	}
	
	return (void*)data;
}

void * LoadFile(const char * filename, size_t * size)
{
	FILE * inf;
	size_t len = 0;
	const int resize_step = 2000;
	char * buff = malloc(32);
	
	inf = fopen (filename,"r");
	if (inf != NULL) {
		while(!feof(inf)) {	//resize buffer until it all fits
			buff = realloc(buff,len+resize_step);
			len += fread(buff+len,sizeof(char),resize_step, inf);
		}
		fclose(inf);
		buff = realloc(buff,len+1);	//trim excess
	}
	
	if (size)
		*size = len;
	
	return buff;
}

int SaveFile(const char * filename, char * string, size_t size)
{
	FILE * of;
	int result;
	
	of = fopen (filename,"w");
	if (of!=NULL) {
		fputs (string,of);
		fclose (of);
		result = 0;
	} else {
		result = 1;
	}
	
	return result;
}

#ifdef _arch_dreamcast
void InitGBR()
{
	SETGBR(&GLOBAL);
}
#endif

