#include "debug.h"
#include <stdlib.h>
#include <ctype.h>

int initialized = 0;


void EPRINT(char * string, int data)
{
	DBOS("%s: %i",string,data);
}

#ifdef _arch_dreamcast
	#include "common.h"
	#include "sh4.h"
#endif

void dump_regs(irq_t source, irq_context_t *context)
{
	uint32 *regs = context->r;
	DBOS("--REG DUMP-- At PC: %08lx, PR: %08lx\n",context->pc,context->pr);
	DBOS(" R0-R7:  %08lx %08lx %08lx %08lx - %08lx %08lx %08lx %08lx\n",
		regs[0], regs[1], regs[2], regs[3], regs[4], regs[5], regs[6], regs[7]);
	DBOS(" R8-R15: %08lx %08lx %08lx %08lx - %08lx %08lx %08lx %08lx\n\n",
		regs[8], regs[9], regs[10], regs[11], regs[12], regs[13], regs[14], regs[15]);
}

void dump_float_regs(irq_t source, irq_context_t *context)
{
	float *fr = (float*)context->fr;
	DBOS("--FLOAT REG DUMP-- At PC: %08lx, PR: %08lx\nFPUL: %+15f\n",context->pc,context->pr);
	DBOS("      %+15f %+15f %+15f %+15f\n", fr[0], fr[4], fr[8],  fr[12]);
	DBOS("      %+15f %+15f %+15f %+15f\n", fr[1], fr[5], fr[9],  fr[13]);
	DBOS("      %+15f %+15f %+15f %+15f\n", fr[2], fr[6], fr[10], fr[14]);
	DBOS("      %+15f %+15f %+15f %+15f\n", fr[3], fr[7], fr[11], fr[15]);
	
}

void dump_float_all_regs(irq_t source, irq_context_t *context)
{
	dump_float_regs(source,context);
	
	float *frbank = (float*)context->fr;
	
	DBOS("XMTRX:\n");
	DBOS("      %+15f %+15f %+15f %+15f\n", frbank[0], frbank[4], frbank[8],  frbank[12]);
	DBOS("      %+15f %+15f %+15f %+15f\n", frbank[1], frbank[5], frbank[9],  frbank[13]);
	DBOS("      %+15f %+15f %+15f %+15f\n", frbank[2], frbank[6], frbank[10], frbank[14]);
	DBOS("      %+15f %+15f %+15f %+15f\n", frbank[3], frbank[7], frbank[11], frbank[15]);
	DBOS("\n");
	
}

