#ifndef _DEBUGGUARD
#define _DEBUGGUARD

#ifdef _arch_dreamcast
	#include <kos.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "watchdog.h"

#ifdef _arch_dreamcast
	#define DBOS(a...) dbglog(DBG_DEAD,a)
	#define DBO(a...) dbglog(DBG_DEAD,a)
#else
	#ifdef USE_CURSES
		#include <ncurses/curses.h>
		#include <unistd.h>
		extern WINDOW *dbgo;
		#define printf(a...) do { wprintw(dbgo,a); wrefresh(dbgo); } while(0)
		#define DBOS(a...) do { wprintw(dbgo,a); wrefresh(dbgo); /* usleep(20000); */ } while(0)
		//#define DBOS(a...) do { DBL(); wprintw(dbgo,a); wrefresh(dbgo); /* usleep(20000); */ } while(0)
		#define DBOS2(a...) do { wprintw(dbgo,a); wrefresh(dbgo); /* usleep(20000); */ } while(0)
		#define DBO(a...) DBOS(a)
	#else
		#define DBOS(a...) do { fprintf(stderr,a); fflush(stderr); } while(0)
		//#define DBO(a...) TEprintf(scriptout,a)
		#error No curses or dreamcast?!
	#endif
#endif

#define DBL() DBOS("[%s %i]\n",__FILE__, __LINE__)

inline static void debug_value_eater(int a) { ; }

#ifndef NDEBUG
	#define check(a...) assert(a)
#else
	#define check(a...) debug_value_eater(a)
#endif
	

#ifdef __cplusplus
extern "C" {
#endif

void DBOfunc(const char *fmt, ...);
void ProfileColorPoint(int red, int green, int blue);
void EPRINT(char * string, int data);
void dump_console();

void dump_regs(irq_t source, irq_context_t *context);
void dump_float_regs(irq_t source, irq_context_t *context);
void dump_float_all_regs(irq_t source, irq_context_t *context);

#ifdef __cplusplus
}
#endif

#endif

