#ifndef _SOAINPUTGUARD
#define _SOAINPUTGUARD

#ifdef USE_SDL
	#include <SDL/SDL.h>
#endif
#include "common.h"

typedef struct {
	int x,y, u,l,r,d, a,b,c,z, sl,sr, s,e,p;	//what's e and p?
} ControllerButtons;

typedef struct {
    ControllerButtons b,c,last;
    float ax,ay,asl,asr;
} Controller;

typedef struct {
    int l,m,r,wu,wd;
} MouseButtons;

typedef struct {
    IVector2D po;
    MouseButtons b,c,last;
} MouseStatus;

#ifdef USE_SDL
	void GetMouseEvent(SDL_Event event, MouseStatus * mou);
#else
	void GetMouseEvent();
	void GetKeyboardEvent();
	void GetJoystickEvent();
#endif
void ClearMouseClick(MouseButtons * b);

extern MouseStatus MOUSE;
extern int INKEY, SHIFT, CTRL, ALT, S1, S2;
extern Controller cont[4];

#endif
