#include "common.h"
#include "render.h"
#include "model.h"


simple_model * LoadSimpleModel(const char *fname)
{
	simple_model *mdl;
	
	watchdog_pause();
	mdl = (simple_model*)LoadCompressed(fname);
	watchdog_resume();
	
	if (mdl != NULL) {
		mdl->strip_lens = SWIZZLE_POINTER(mdl->strip_lens,mdl);
		mdl->vertices = SWIZZLE_POINTER(mdl->vertices,mdl);
	}
	
	return mdl;
}

void DrawSimpleModel(simple_model *mdl, float lx, float ly, float lz, float ambient)
{
	pvr_sq_init();
	render_strip_array_mix((void *)0xe0000000, mdl->vertices, mdl->strip_count, mdl->strip_lens, lx, ly, lz, 0, ambient);
}

void DrawSimpleModel2(simple_model *mdl, float lx, float ly, float lz, float ambient)
{
	pvr_sq_init();
	
	int i = mdl->strip_count;
	size_t *strip_len = mdl->strip_lens;
	mixvertex_t *vertices = mdl->vertices;
	do {
		render_strip_mix((pvr_vertex_t *)0xe0000000, vertices, *strip_len, lx, ly, lz, 0, ambient);
		vertices += *strip_len++;
	} while(--i);
}



