#ifndef _PROFILE_GUARD
#define _PROFILE_GUARD

#ifdef __cplusplus
extern "C" {
#endif

#include <kos.h>
#include <time.h>

typedef uint64 profile_t;

static inline profile_t PfStart() {
	return timer_us_gettime64();
}

static inline profile_t PfEnd(profile_t start) {
	profile_t end = timer_us_gettime64();
	return end-start;
}

float PfSecs(profile_t time);
float PfCycles(profile_t time);
float PfCycLoop(profile_t time, int loops);

void ProfileColorPoint(int red, int green, int blue);

void profile_init(size_t size);
void profile_reset(void);
void profile_shutdown(void);
void profile_go(void);
void profile_stop(void);
int profile_running(void);
int profile_save(const char *fname, int append);

#ifdef __cplusplus
}
#endif

#endif
