#ifndef _RENDERGUARD
#define _RENDERGUARD

typedef struct {
	float x,y,z;
	float u;
	float nx,ny,nz;
	float v;
} mixvertex_t;

#define pvr_sq_init() do { \
        QACR1 = ((((uint32)PVR_TA_INPUT) >> 26) << 2) & 0x1c; \
        QACR0 = ((((uint32)PVR_TA_INPUT) >> 26) << 2) & 0x1c; \
	} while(0)

	
#define PVR_FGET(REG) (* ( (float*)( 0xa05f8000 + (REG) ) ) )
#define PVR_FSET(REG, VALUE) PVR_FGET(REG) = (VALUE)

#define PVR_SMALL_CULL          0x0078  // Minimum size of polygons for when culling is not PVR_CULLING_NONE
	
#ifdef __cplusplus
extern "C" {
#endif
	int submit_commands(void * rendertarget, void * vertexlist, int vertcount);
	
	int render_strip_mix(void * rendertarget, mixvertex_t * vertlist, int vertcount,
		float lightx, float lighty, float lightz, float lightw, float ambient);
	int render_strip_array_mix(void * rendertarget, mixvertex_t * vertlist, size_t stripcount, size_t * striplens,
		float lightx, float lighty, float lightz, float lightw, float ambient);
	
	
#ifdef __cplusplus
}
#endif

#endif
