#ifndef _SH4GUARD
#define _SH4GUARD

#define aligned32 __attribute__((aligned(32)))

#define NONCACHED(a) (typeof (a))(((unsigned int)(a)) |  (1 << 29))
#define CACHED(a)    (typeof (a))(((unsigned int)(a)) & ~(1 << 29))
#define OCI_BANK0(a) (typeof (a))(((unsigned int)(a)) & ~(1 << 25))
#define OCI_BANK1(a) (typeof (a))(((unsigned int)(a)) |  (1 << 25))

#define ANGLE_TO_RAD(r)		((r) / 10430.37835f)
#define RAD_TO_ANGLE(r)		((r) * 10430.37835f)

#define xstr(s) str(s)
#define str(s) #s

#define prefetch(addr) __asm__ __volatile__("pref @%0" : : "r" (addr))
#define writeback(addr) __asm__ __volatile__("ocbwb @%0" : : "r" (addr) : "memory")
//#define invalidate(addr) __asm__ __volatile__("ocbi @%0" : : "r" (addr))
//#define purge(addr) __asm__ __volatile__("ocbp @%0" : : "r" (addr))
#define special_nop(addr) __asm__ __volatile__("nop" : : "r" (addr))
//#define mem_barrier() __asm__ __volatile__("" : : : "memory")


#define __swapb(x) \
({ int __value, __arg = (x); \
	__asm__(	"swap.b	%1,%0\n\t" \
	: "=r" (__value) \
	: "r" (__arg) \
	); \
	__value; })

#define __swapw(x) \
({ int __value, __arg = (x); \
	__asm__(	"swap.w	%1,%0\n\t" \
	: "=r" (__value) \
	: "r" (__arg) \
	); \
	__value; })

/* #define __xtrct(x,y) \
({ int __value = (y), __arg = (x); \
	__asm__(	"xtrct	%1,%0\n\t" \
	: "=r" (__value) \
	: "r" (__arg, __value) \
	); \
	__value; }) */
	
#define __xtrct(x,y) \
({ int __value = (y), __arg = (x); \
	__asm__(	"xtrct	%1,%0\n\t" \
	: "=r" (__value) \
	: "r" (__arg), \
	 "0" (__value) \
	); \
	__value; })
	
#define __swapgbr(x) \
({ void * __value, * __arg = (x); \
	__asm__(	"stc gbr,%0\n\t" \
			"ldc %1,gbr\n\t" \
	: "=r" (__value) \
	: "r" (__arg) \
	); \
	__value; })
	
#define __setgbr(x) \
({ void * __arg = (x); \
	__asm__(	"ldc %0,gbr\n\t" \
	:  \
	: "r" (__arg) \
	); \
	})
	
#define __getgbr() \
({ void * __value; \
	__asm__(	"stc gbr,%0\n\t" \
	: "=r" (__value) \
	); \
	__value; })
	
#define __extsb(x) \
({ int __value, __arg = (x); \
	__asm__(	"exts.b	%1,%0\n\t" \
	: "=r" (__value) \
	: "r" (__arg) \
	); \
	__value; })

#define __extsw(x) \
({ int __value, __arg = (x); \
	__asm__(	"exts.w	%1,%0\n\t" \
	: "=r" (__value) \
	: "r" (__arg) \
	); \
	__value; })
	
#define __extub(x) \
({ int __value, __arg = (x); \
	__asm__(	"extu.b	%1,%0\n\t" \
	: "=r" (__value) \
	: "r" (__arg) \
	); \
	__value; })
	
#define __extuw(x) \
({ int __value, __arg = (x); \
	__asm__(	"extu.w	%1,%0\n\t" \
	: "=r" (__value) \
	: "r" (__arg) \
	); \
	__value; })
	
//addr MUST be a compile-time constant literal
#define GBR_LOAD_B(addr) \
({ register int __value  __asm__("r0"); \
	int __value2; \
	__asm__ __volatile__ (	\
		"mov.b @( " xstr(addr) " ,gbr),r0\n\t" \
	: "=r" (__value) ); \
	__value2 = __value; \
	__value2; })

//addr MUST be a compile-time constant literal	
#define GBR_LOAD_W(addr) \
({ register int __value  __asm__("r0"); \
	int __value2; \
	__asm__  __volatile__ (	\
		"mov.w @( " xstr(addr) " ,gbr),r0\n\t" \
	: "=r" (__value) ); \
	__value2 = __value; \
	__value2; })

//addr MUST be a compile-time constant literal	
#define GBR_LOAD_L(addr) \
({ register int __value  __asm__("r0"); \
	int __value2; \
	__asm__ __volatile__ (	\
		"mov.L @( " xstr(addr) " ,gbr),r0\n\t" \
	: "=r" (__value) ); \
	__value2 = __value; \
	__value2; })
	
//addr MUST be a compile-time constant literal	
#define GBR_LOAD_F(addr) \
({ register float __value; \
	__asm__ __volatile__ (	\
		"mov.L @( " xstr(addr) " ,gbr),r0\n\t" \
		"lds r0,fpul\n\t" \
		"fsts fpul,%0" \
	: "=f" (__value)  \
	: \
	: "r0", "fpul" ); \
	__value; })
	

/*#define GBR_LOAD_L(addr) \
({ int __value; \
	__asm__ __volatile__ (	\
		"mov.L @( " #addr " ,gbr),r0\n\t" \
		"mov r0,%0\n\t" \
	: "=r" (__value) \
	: \
	: "r0" ); \
	__value; })*/

//addr MUST be a compile-time constant literal
#define GBR_STORE_B(addr,val) \
({ register int __value  __asm__("r0") = val; \
	__asm__ __volatile__ (	\
		"mov.b r0,@( " xstr(addr) " ,gbr)\n\t" \
	:  \
	: "r" (__value) \
	: "memory"  ); \
	__value; })

//addr MUST be a compile-time constant literal
#define GBR_STORE_W(addr,val) \
({ register int __value  __asm__("r0") = val; \
	__asm__ __volatile__ (	\
		"mov.w r0,@( " xstr(addr) " ,gbr)\n\t" \
	:  \
	: "r" (__value) \
	: "memory"  ); \
	__value; })
	
//addr MUST be a compile-time constant literal
#define GBR_STORE_L(addr,val) \
({ register int __value  __asm__("r0") = val; \
	__asm__ __volatile__ (	\
		"mov.l r0,@( " xstr(addr) " ,gbr)\n\t" \
	:  \
	: "r" (__value) \
	: "memory"  ); \
	__value; })
	
//addr MUST be a compile-time constant literal
#define GBR_STORE_F(addr,val) \
({ register float __value = val; \
	__asm__ __volatile__ (	\
		"flds %0, fpul\n\t" \
		"sts fpul,r0\n\t" \
		"mov.l r0,@( " xstr(addr) " ,gbr)\n\t" \
	:  \
	: "f" (__value) \
	: "r0", "fpul", "memory"  ); \
	__value; })
	
//val MUST be a compile-time constant literal
#define GBR_OR_B(addr,val) \
({ register int __addr __asm__("r0") = addr; \
	__asm__ __volatile__ (	\
		"or.b #" xstr(val) "@(r0,gbr)\n\t" \
	:  \
	: "r" (__addr) ); \
	})

//val MUST be a compile-time constant literal
#define GBR_XOR_B(addr,val) \
({ register int __addr __asm__("r0") = addr; \
	__asm__ __volatile__ (	\
		"xor.b #" xstr(val) "@(r0,gbr)\n\t" \
	:  \
	: "r" (__addr) ); \
	})
	
//val MUST be a compile-time constant literal
#define GBR_AND_B(addr,val) \
({ register int __addr __asm__("r0") = addr; \
	__asm__ __volatile__ (	\
		"and.b #" xstr(val) "@(r0,gbr)\n\t" \
	:  \
	: "r" (__addr) ); \
	})

	
//val MUST be a compile-time constant literal
/* 	returns inverted t bit because sh4 does tst as follows:
		if ((gbr[addr] & val) == 0) t = 1; else t = 0;
	which has the side effect of reversing true and false compared to the more conventional
		if (gbr[addr] & val) t = 1; else t = 0;
	
	this macro is useless because the code generated by gcc for using this in an if statement is
	one instruction larger than using an GBR_LOAD_B followed by an & operator.

	-- if (GBR_TST_B(0,1)) { ... }
		mov     #0,r0
		tst.b   #1,@(r0,gbr)
		movt    r0
		tst     r0,r0
		bt      somewhere
		
	-- if (GBR_LOAD_B(0) & 1) { ... }
		mov.b   @(0,gbr),r0
		and     #1,r0
		tst     r0,r0
		bf      somewhere
		
	-- if (GBR_LOAD_B(0) & 1) { ... } and if GCC is smarter
		mov.b   @(0,gbr),r0
		tst     #1,r0
		bf      somewhere
		
	-- if (GBR_TST_B(0,1)) { ... } ideally
		mov     #0,r0
		tst.b   #1,@(r0,gbr)
		bt      somewhere
*/	

#define GBR_TST_B(addr,val) \
({ register int __addr __asm__("r0") = addr, __result; \
	__asm__ __volatile__ (	\
		"tst.b #" #val "@(r0,gbr)\n\t" \
		"movt %0\n\t" \
	: "=r" (__result) \
	: "r" (__addr)\
	: "t" ); \
	!__result; })
	
//below macro doesn't work. it compiles, but produces the wrong result.
#define GBR_TST_B2(addr,val) \
({ register int __addr __asm__("r0") = addr; register int __result __asm__("t"); \
	__asm__ __volatile__ (	\
		"tst.b #" #val "@(r0,gbr)\n\t" \
	: "=r" (__result) \
	: "r" (__addr)\
	 ); \
	__result; })
	
#define fisincos(a,sine,cosine) \
({	asm(	"lds	%2,fpul\n\t" \
		".short	0xf0fd\n\t" \
		"fmov	fr0,%0\n\t" \
		"fmov	fr1,%1\n\t" \
	: "=f" (sine), "=f" (cosine) \
	: "r" (a) \
	: "fpul", "fr0", "fr1"); \
	 })
//

static inline void __sh4func_fsincos(float a, float *sine, float *cosine)
{
	register float __s __asm__("fr2");
	register float __c __asm__("fr3");
	a *= 10430.37835;
	
        asm(    "ftrc	%2,fpul\n\t"
                "fsca	fpul,dr2\n\t"
		: "=f" (__s), "=f" (__c)
		: "f" (a)
		: "fpul");
	
        *sine = __s; *cosine = __c;
}


static inline void fisincosf(int angle, float *s, float *c)
{
	__sh4func_fsincos(angle,s,c);
}

static inline void fsincosf(float rad, float *s, float *c)
{
	__sh4func_fsincos(RAD_TO_ANGLE(rad),s,c);
}

static inline int SWAPB(int f) {
	return __swapb(f);
}

static inline int SWAPW(int f) {
	return __swapw(f);
}

static inline int BSWAP(int f) {
	return SWAPB(SWAPW(SWAPB(f)));
}

static inline int XTRCT(int a, int b) {
	return __xtrct(a,b);
}

static inline void * GETGBR() {
	return __getgbr();
}

static inline void SETGBR(void * f) {
	__setgbr(f);
}

static inline void * SWAPGBR(void * f) {
	return __swapgbr(f);
}

static inline char EXTSB(int f) {
	return (f);
}

static inline short EXTSW(int f) {
	return (f);
}

static inline unsigned char EXTUB(int f) {
	return (f);
}

static inline unsigned short EXTUW(int f) {
	return (f);
}

static inline unsigned int GET_FPSCR() {
	int ret;
	
	__asm__( "sts	fpscr,%0\n\t" : "=r" (ret) );
	
	return ret;
}

static inline unsigned int SET_FPSCR(unsigned int newfpscr) {
	int ret;
	
	__asm__( "lds	%0,fpscr\n\t" : : "r" (newfpscr) );
	
	return ret;
}

//MATH
/*

static inline float __sh4func_fabsf(float a)
{
	asm( "fabs %0\n\t"  : "=f" (a) : "0" (a) );
	return a;
}

static inline float __sh4func_fsqrt(float a)
{
        asm( "fsqrt %0\n\t" : "=f" (a) : "0" (a) );
        return a;
}

static inline void __sh4func_fsincos(float a, float *sine, float *cosine)
{
	register float __s __asm__("fr2");
	register float __c __asm__("fr3");
	a *= 10430.37835;
	
        asm(    "ftrc	%2,fpul\n\t"
                "fsca	fpul,dr2\n\t"
		: "=f" (__s), "=f" (__c)
		: "f" (a)
		: "fpul");
	
        *sine = __s; *cosine = __c;
}
static inline float __sh4func_fsin(float a)
{
	float sin_result, cos_temp;
	__sh4func_fsincos(a,&sin_result,&cos_temp);
	return sin_result;
}
static inline float __sh4func_fcos(float a)
{
	float sin_temp, cos_result;
	__sh4func_fsincos(a,&sin_temp,&cos_result);
	return cos_result;
}
static inline float __sh4func_ftan(float a)
{
	float sin_result, cos_result;
	__sh4func_fsincos(a,&sin_result,&cos_result);
	return sin_result/cos_result;
}
static inline float __sh4func_rsqrtf(float a)
{
	asm(    "fsrra %0\n\t" : "=f" (a) : "0" (a));
	return a;
}
#define fabsf(a) __sh4func_fabsf(a)
#define absf(a) __sh4func_fabsf(a)
#define fabs(a) __sh4func_fabsf(a)
#define abs(a) __sh4func_fabsf(a)
#define sqrtf(a) __sh4func_fsqrt(a)
#define sinf(a) __sh4func_fsin(a)
#define cosf(a) __sh4func_fcos(a)
#define tanf(a) __sh4func_ftan(a)
static inline float __sh4func_fneg(float a)
{
	asm(    "fneg %0\n\t" : "=f" (a) : "0" (a));
	return a;
}
#define fneg(a) __sh4func_fneg(a)

//*/


/*extern inline char LOADGBRB0() {
	return __loadgbrb0();
}

extern inline int LOADGBRB(int f) {
	return __loadgbrb(f);
}

extern inline void STOREGBRB(int f) {
	__storegbrb(f);
}*/

/* Small function for packing two 32-bit u/v values into
   two 16-bit u/v values. */
static inline unsigned int PVR_PACK_16BIT_UV_XTRCT(float u, float v) {
	return XTRCT( ((*((unsigned int *) &v)) >> 16 ), ((*((unsigned int *) &u)) >> 0 ) );
}

/* Transform vector, without any perspective division. */
#define mat_trans_nodiv(x, y, z, w) { \
	register float __x __asm__("fr0") = (x); \
	register float __y __asm__("fr1") = (y); \
	register float __z __asm__("fr2") = (z); \
	register float __w __asm__("fr3") = (w); \
	__asm__ __volatile__( \
		"ftrv   xmtrx,fv0\n" \
		: "=f" (__x), "=f" (__y), "=f" (__z), "=f" (__w) \
		: "0" (__x), "1" (__y), "2" (__z), "3" (__w) ); \
	x = __x; y = __y; z = __z; w = __w; \
}

//With constant W
#define mat_trans_nodiv_cw(x, y, z, w) { \
	register float __x __asm__("fr0") = (x); \
	register float __y __asm__("fr1") = (y); \
	register float __z __asm__("fr2") = (z); \
	register float __w __asm__("fr3") = (w); \
	__asm__ __volatile__( \
		"ftrv   xmtrx,fv0\n" \
		: "=f" (__x), "=f" (__y), "=f" (__z), "=f" (__w) \
		: "0" (__x), "1" (__y), "2" (__z), "3" (__w) ); \
	x = __x; y = __y; z = __z;\
}

/* Transform vector, without any perspective division. */
#define mat_trans_nodiv_param(x, y, z, w) { \
	register float __x __asm__("fr4") = (x); \
	register float __y __asm__("fr5") = (y); \
	register float __z __asm__("fr6") = (z); \
	register float __w __asm__("fr7") = (w); \
	__asm__ __volatile__( \
		"ftrv   xmtrx,fv0\n" \
		: "=f" (__x), "=f" (__y), "=f" (__z), "=f" (__w) \
		: "0" (__x), "1" (__y), "2" (__z), "3" (__w) ); \
	x = __x; y = __y; z = __z; w = __w; \
}

/* Transform vector, without any perspective division. */
#define mat_trans_2d_single(x, y) { \
	register float __x __asm__("fr0") = (x); \
	register float __y __asm__("fr1") = (y); \
	register float __z __asm__("fr2") = (0); \
	register float __w __asm__("fr3") = (1); \
	__asm__ __volatile__( \
		"ftrv   xmtrx,fv0\n" \
		: "=f" (__x), "=f" (__y), "=f" (__z), "=f" (__w) \
		: "0" (__x), "1" (__y), "2" (__z), "3" (__w) ); \
	x = __x; y = __y; \
}


#define GET_XF_MACRO(name,register)	\
static inline float name()	\
{	\
	float result;	\
	asm(	\
		"frchg\n\t\
		flds	" xstr(register) ",fpul\n\t\
		frchg\n\t\
		fsts	fpul,%0\n\t"	\
		: "=f" (result) \
		: \
		: "fpul"); \
	return result; \
} \
/* end */
 
GET_XF_MACRO(get_xf0,fr0)
GET_XF_MACRO(get_xf1,fr1)
GET_XF_MACRO(get_xf4,fr4)
GET_XF_MACRO(get_xf5,fr5)
GET_XF_MACRO(get_xf10,fr10)
GET_XF_MACRO(get_xf15,fr15)

#undef GET_XF_MACRO


#endif
